if select(2, UnitClass("player")) ~= "PRIEST" then return end
local GetSpellInfo = GetSpellInfo

--No baseincrease: Mind Flay, Circle of Healing, Devouring Plague, Vampiric Touch, SW: D, SW: P

function DrDamage:PlayerData()

	--TODO: Glyph of Power Word: Shield
	--TODO: Glyph of Prayer of Healing
	--TODO: Improved Flash Heal
	--TODO: Focused Will?
	
	--General
	self.Calculation["PRIEST"] = function ( calculation, ActiveAuras, Talents )
		if ActiveAuras["Shadowform"] then
			calculation.dmgM = calculation.dmgM * 1.15
		end
		--TODO: Fix some friendly target check here
		if Talents["Test of Faith"] then
			if (UnitHealth("target") / UnitHealthMax("target")) <= 0.5 then
				calculation.dmgM = calculation.dmgM * (1 + Talents["Test of Faith"])
			end		
		end
	end
	
	--Spells
	self.Calculation["Mind Blast"] = function ( calculation, ActiveAuras, BuffTalentRanks )
		if ActiveAuras["Shadow Word: Pain"] and BuffTalentRanks["Twisted Faith"] then
 			calculation.dmgM = calculation.dmgM * (1 + BuffTalentRanks["Twisted Faith"])
		end
	end
	self.Calculation["Mind Flay"] = function ( calculation, ActiveAuras, BuffTalentRanks )
		if ActiveAuras["Shadow Word: Pain"] and BuffTalentRanks["Twisted Faith"] then
			--Glyph of Shadow Word: Pain
 			calculation.dmgM = calculation.dmgM * (1 + BuffTalentRanks["Twisted Faith"] + (self:HasGlyph(55687) and 0.1 or 0))
		end
	end
	self.Calculation["Shadow Word: Pain"] = function ( calculation, ActiveAuras )
		if ActiveAuras["Shadowform"] then
			calculation.canCrit = true
			calculation.critM = calculation.critM + 0.5
		end
	end
	self.Calculation["Vampiric Touch"] = self.Calculation["Shadow Word: Pain"]
	self.Calculation["Devouring Plague"] = function ( calculation, ActiveAuras, BuffTalentRanks )
		if ActiveAuras["Shadowform"] then
			calculation.canCrit = true
			calculation.critM = calculation.critM + 0.5
		end
		if BuffTalentRanks["Improved Devouring Plague"] then
			calculation.bNukeDmgM = BuffTalentRanks["Improved Devouring Plague"]
			calculation.hybridDotDmg = (calculation.minDam + calculation.maxDam) / 2
			--calculation.spellDmgM = calculation.spellDmgM + BuffTalentRanks["Improved Devouring Plague"]
			calculation.dotSpellDmgM = calculation.spellDmgM
			calculation.canCrit = true
		end		
	end
	self.Calculation["Renew"] = function ( calculation, _, BuffTalentRanks )
		--Glyph of Renew
		if self:HasGlyph(55674) then
			calculation.eDuration = calculation.eDuration - 3
		end
		if BuffTalentRanks["Empowered Renew"] then
			calculation.bNukeDmgM = BuffTalentRanks["Empowered Renew"]
			calculation.hybridDotDmg = ((calculation.minDam + calculation.maxDam) / 2)
			--calculation.spellDmgM = calculation.spellDmgM * (1 + BuffTalentRanks["Empowered Renew"])
			calculation.dotSpellDmgM = calculation.spellDmgM
			calculation.spellDmgM = 0
			calculation.canCrit = true
		end
	end
	self.Calculation["Holy Nova"] = function( calculation )
		--Glyph of Holy Nova
		if self:HasGlyph(55683) then
			if calculation.healingSpell then
				calculation.dmgM = calculation.dmgM * 1.4
			else
				calculation.dmgM = calculation.dmgM * 0.6
			end
		end
	end
	self.Calculation["Lightwell"] = function( calculation )
		--Glyph of Lightwell
		if self:HasGlyph(55673) then
			calculation.dmgM = calculation.dmgM * 1.2
		end
	end
	self.Calculation["Shadow Word: Death"] = function( calculation )
		--Glyph of Shadow Word: Death
		if self:HasGlyph(55682) then
			if (UnitHealth("target") / UnitHealthMax("target")) <= 0.35 then
				calculation.dmgM = calculation.dmgM * 1.1
			end
		end
	end
	self.Calculation["Smite"] = function ( calculation, ActiveAuras, BuffTalentRanks )
		--Glyph of Smite
		if self:HasGlyph(55692) and ActiveAuras["Holy Fire"] then
 			calculation.dmgM = calculation.dmgM * 1.2
		end
	end	
	
	--Set bonuses
	
	--Sets
	self.SetBonuses["Tier 8 - Damage"] = { 46163, 46165, 46168, 46170, 46172, 45391, 45392, 45393, 45394, 45395 }
	self.SetBonuses["Tier 8 - Healing"] = { 46188, 46190, 46193, 46195, 46197, 45386, 45387, 45388, 45389, 45390 }
	self.SetBonuses["Tier 7 - Damage"] = { 40454, 40456, 40457, 40458, 40459, 39521, 39523, 39528, 39529, 39530 }
	self.SetBonuses["Tier 7 - Healing"] = { 40445, 40447, 40448, 40449, 40450, 39514, 39515, 39517, 39518, 39519  }
	
	--Effects
	self.SetBonuses["Devouring Plague"] = function( calculation )
		if self:GetSetAmount( "Tier 8 - Damage" ) >= 2 then
			calculation.dmgM = calculation.dmgM * 1.15
		end	
	end
	self.SetBonuses["Prayer of Healing"] = function( calculation )
		if self:GetSetAmount( "Tier 8 - Healing" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 10
		end	
	end
	self.SetBonuses["Shadow Word: Death"] = function( calculation )
		if self:GetSetAmount( "Tier 7 - Damage" ) >= 4 then
			calculation.critPerc = calculation.critPerc + 10
		end	
	end
	self.SetBonuses["Prayer of Mending"] = function( calculation )
		if self:GetSetAmount( "Tier 7 - Healing" ) >= 2 then
			calculation.sHits = calculation.sHits + 1
		end	
	end	
	
	--AURAS
	--Shadowform
	--Borrowed time
	--Shadow Weaving
	self.PlayerAura[GetSpellInfo(15473)] = { School = "Shadow", ModType = "ActiveAura", ActiveAura = "Shadowform" }
	self.PlayerAura[GetSpellInfo(59891)] = { ModType = "Update" }
	self.PlayerAura[GetSpellInfo(15258)] =  { School = "Shadow", Value = 0.02, Apps = 5 }
	--Grace
	--Shadow Word: Pain
	--Weakened Soul
	--Holy Fire
	self.TargetAura[GetSpellInfo(47516)] =  { School = "Healing", Value = 0.03, Apps = 3, SelfCastBuff = true }
	self.TargetAura[GetSpellInfo(589)] = { ModType = "ActiveAura", ActiveAura = "Shadow Word: Pain" }
	self.TargetAura[GetSpellInfo(6788)] = { Spell = { GetSpellInfo(53007), GetSpellInfo(2061), GetSpellInfo(2060) }, ModType = "Special" }
	self.TargetAura[GetSpellInfo(14914)] = { Spell = GetSpellInfo(585), ModType = "ActiveAura", ActiveAura = "Holy Fire" }
	
	--Weakened Soul
	self.Calculation[GetSpellInfo(6788)] = function( calculation, _, Talents )
		if Talents["Renewed Hope"] and calculation.healingSpell then
			calculation.critPerc = calculation.critPerc + Talents["Renewed Hope"]
		end
	end
	
	--SPELLS
	--Mind Flay
	self.spellInfo = { 
		[GetSpellInfo(15407)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Mind Flay", 
					[0] = { School = "Shadow", canCrit = true, castTime = 3, bonusFactor = 0.771, sTicks = 1, },
					[1] = { 45, 45, spellLevel = 20, },
					[2] = { 108, 108, spellLevel = 28, },
					[3] = { 159, 159, spellLevel = 36, },
					[4] = { 222, 222, spellLevel = 44, },
					[5] = { 282, 282, spellLevel = 52, },
					[6] = { 363, 363, spellLevel = 60, },
					[7] = { 450, 450, spellLevel = 68, },
					[8] = { 492, 492, spellLevel = 74, },
					[9] = { 588, 588, spellLevel = 80, },
		},
	-- Devouring Plague		
		[GetSpellInfo(2944)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Devouring Plague",
					[0] = { School = "Shadow", eDot = true, eDuration = 24, bonusFactor = 1.4792, Cooldown = 24, sTicks = 3, },
					[1] = { 152, 152, spellLevel = 20, },
					[2] = { 272, 272, spellLevel = 28, },
					[3] = { 400, 400, spellLevel = 36, },
					[4] = { 544, 544, spellLevel = 44, },
					[5] = { 712, 712, spellLevel = 52, },
					[6] = { 904, 904, spellLevel = 60, },
					[7] = { 1088, 1088, spellLevel = 68, },
					[8] = { 1144, 1144, spellLevel = 73, },
					[9] = { 1376, 1376, spellLevel = 79, },
		},
	-- Shadow Word: Pain
		[GetSpellInfo(589)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Shadow Word: Pain",
					[0] = { School = "Shadow", eDot = true, eDuration = 18 , bonusFactor = 1.1, sTicks = 3, NoDownRank = true },
					[1] = { 30, 30, spellLevel = 4, },
					[2] = { 60, 60, spellLevel = 10, },
					[3] = { 120, 120, spellLevel = 18, },
					[4] = { 210, 210, spellLevel = 26, },
					[5] = { 330, 330, spellLevel = 34, },
					[6] = { 462, 462, spellLevel = 42, },
					[7] = { 606, 606, spellLevel = 50, },
					[8] = { 768, 768, spellLevel = 58, },
					[9] = { 906, 906, spellLevel = 65, },
					[10] = { 1116, 1116, spellLevel = 70, },
					[11] = { 1176, 1176, spellLevel = 75, },
					[12] = { 1380, 1380, spellLevel = 80, },
		},
	-- Vampiric Touch
		[GetSpellInfo(34914)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Vampiric Touch",
					[0] = { School = "Shadow", eDot = true, bonusFactor = 2, eDuration = 15, sTicks = 3, },
					[1] = { 450, 450, spellLevel = 50, },
					[2] = { 600, 600, spellLevel = 60, },	
					[3] = { 650, 650, spellLevel = 70, },	
					[4] = { 735, 735, spellLevel = 75, },	
					[5] = { 850, 850, spellLevel = 80, },	
		},
	-- Shadow Word: Death	
		[GetSpellInfo(32379)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Shadow Word: Death",
					[0] = { School = "Shadow", canCrit = true, Cooldown = 12, },
					[1] = { 450, 522, spellLevel = 62, },
					[2] = { 572, 664, spellLevel = 70, },		
					[3] = { 639, 741, spellLevel = 75, },
					[4] = { 750, 870, spellLevel = 80, },				
		},
	-- Mind Blast
		[GetSpellInfo(8092)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Mind Blast",
					[0] = { School = "Shadow", canCrit = true, Cooldown = 8, BaseIncrease = true, LevelIncrease = 5 },
					[1] = { 39, 43, 3, 3, spellLevel = 10, },
					[2] = { 72, 78, 4, 5, spellLevel = 16, },
					[3] = { 112, 120, 5, 6, spellLevel = 22, },
					[4] = { 167, 177, 7, 7, spellLevel = 28, },
					[5] = { 217, 231, 8, 8, spellLevel = 34, },
					[6] = { 279, 297, 9, 10, spellLevel = 40, },
					[7] = { 346, 366, 10, 11, spellLevel = 46, },
					[8] = { 425, 449, 12, 12, spellLevel = 52, },
					[9] = { 503, 531, 13, 13, spellLevel = 58, },
					[10] = { 557, 587, 14, 15, spellLevel = 63, },
					[11] = { 708, 748, 16, 17, spellLevel = 69, }, --Guess --DALLYTEMP
					[12] = { 837, 883, 0, 0, spellLevel = 74, },
					[13] = { 992, 1048, 0, 0, spellLevel = 79, },
		},
	-- Power Word: Shield
		[GetSpellInfo(17)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Power Word: Shield",
					[0] = { School = "Holy", Healing = true, Cooldown = 4, NoDPS = true, NoDebuffs = true, NoDoom = true, BaseIncrease = true, LevelIncrease = 5 },
					[1] = { 44, 44, 4, 4, spellLevel = 6, },
					[2] = { 88, 88, 6, 6, spellLevel = 12, },
					[3] = { 158, 158, 8, 8, spellLevel = 18, },
					[4] = { 234, 234, 10, 10, spellLevel = 24, },
					[5] = { 301, 301, 11, 11, spellLevel = 30, },
					[6] = { 381, 381, 13, 13, spellLevel = 36, },
					[7] = { 484, 484, 15, 15, spellLevel = 42, },
					[8] = { 605, 605, 17, 17, spellLevel = 48, },
					[9] = { 763, 763, 19, 19, spellLevel = 54, },
					[10] = { 942, 942, 21, 21, spellLevel = 60, },
					[11] = { 1125, 1125, 18, 18, spellLevel = 65, },
					[12] = { 1265, 1265, 0, 0, spellLevel = 70, },
					[13] = { 1920, 1920, 0, 0, spellLevel = 75, },
					[14] = { 2230, 2230, 0, 0, spellLevel = 80, },
		},
	-- Heal
		[GetSpellInfo(2054)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Heal",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 3, BaseIncrease = true,  LevelIncrease = 5 },
					[1] = { 295, 341, 12, 12, spellLevel = 16, },
					[2] = { 429, 491, 16, 16, spellLevel = 22, },
					[3] = { 566, 642, 20, 20, spellLevel = 28, },
					[4] = { 712, 804, 22, 23, spellLevel = 34, },
		},
	-- Lesser Heal
		[GetSpellInfo(2050)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Lesser Heal",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 2.5, BaseIncrease = true, LevelIncrease = 5 },
					[1] = { 46, 56, 1, 2, spellLevel = 1, castTime = 1.5, },
					[2] = { 71, 85, 5, 6, spellLevel = 4, castTime = 2, },
					[3] = { 135, 157, 8, 8, spellLevel = 10, },			
		},
	-- Greater Heal			
		[GetSpellInfo(2060)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Greater Heal",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 3, BaseIncrease = true, LevelIncrease = 5 },
					[1] = { 899, 1013, 25, 26, spellLevel = 40, },
					[2] = { 1149, 1289, 29, 29, spellLevel = 46, },
					[3] = { 1437, 1609, 33, 33, spellLevel = 52, },
					[4] = { 1798, 2006, 37, 38, spellLevel = 58, },
					[5] = { 1966, 2194, 40, 41, spellLevel = 60, },
					[6] = { 2074, 2410, 33, 34, spellLevel = 63, },
					[7] = { 2396, 2784, 45, 46, spellLevel = 68, },	--Guess --DALLYTEMP
					[8] = { 3395, 3945, 0, 0, spellLevel = 73, },
					[9] = { 3950, 4590, 0, 0, spellLevel = 78, },			
		},
	-- Prayer of Healing
		[GetSpellInfo(596)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Prayer of Healing",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 3, Healing = true, bonusFactor = 1.5/3.5, BaseIncrease = true, LevelIncrease = 9 },
					[1] = { 301, 321, 11, 12, spellLevel = 30, },
					[2] = { 444, 472, 14, 15, spellLevel = 40, },
					[3] = { 657, 695, 15, 18, spellLevel = 50, },
					[4] = { 939, 991, 14, 15, spellLevel = 60, },
					[5] = { 997, 1053, 22, 23, spellLevel = 60, },
					[6] = { 1246, 1316, 23, 24, spellLevel = 68, }, --Guess --DALLYTEMP
					[7] = { 2091, 2209, 0, 0, spellLevel = 76, },
		},
	-- Circle of Healing
		[GetSpellInfo(34861)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Circle of Healing",
					[0] = { School = { "Holy", "Healing" }, sFactor = 0.5 },
					[1] = { 343, 379, spellLevel = 50, },
					[2] = { 403, 445, spellLevel = 56, },
					[3] = { 458, 506, spellLevel = 60, },
					[4] = { 518, 572, spellLevel = 65, },
					[5] = { 572, 632, spellLevel = 70, },
					[6] = { 825, 911, spellLevel = 75, },
					[7] = { 958, 1058, spellLevel = 80, },
		},
	-- Flash Heal		
		[GetSpellInfo(2061)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Flash Heal",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, BaseIncrease = true,  LevelIncrease = 5 },
					[1] = { 193, 237, 9, 10, spellLevel = 20, },
					[2] = { 258, 314, 11, 11, spellLevel = 26, },
					[3] = { 327, 393, 12, 13, spellLevel = 32, },
					[4] = { 400, 478, 14, 14, spellLevel = 38, },
					[5] = { 518, 616, 16, 17, spellLevel = 44, },
					[6] = { 644, 764, 18, 19, spellLevel = 52, },
					[7] = { 812, 958, 21, 21, spellLevel = 58, },
					[8] = { 913, 1059, 18, 19, spellLevel = 61, },
					[9] = { 1101, 1279, 26, 27, spellLevel = 67, }, --Guess --DALLYTEMP
					[10] = { 1578, 1832, 0, 0, spellLevel = 73, },
					[11] = { 1887, 2193, 0, 0, spellLevel = 79, },
		},
	-- Desperate Prayer
		[GetSpellInfo(19236)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Desperate Prayer",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, NoDoom = true, BaseIncrease = true, LevelIncrease = 7 },
					[1] = { 263, 325, 20, 21, spellLevel = 20, },
					[2] = { 447, 543, 27, 27, spellLevel = 26, },
					[3] = { 588, 708, 31, 32, spellLevel = 34, },
					[4] = { 834, 994, 38, 39, spellLevel = 42, },
					[5] = { 1101, 1305, 44, 45, spellLevel = 50, },
					[6] = { 1324, 1562, 50, 51, spellLevel = 58, },
					[7] = { 1601, 1887, 56, 57, spellLevel = 66, }, --Guess --DALLYTEMP
					[8] = { 3111, 3699, 0, 0, spellLevel = 73, },
					[9] = { 3716, 4384, 0, 0, spellLevel = 80, },
		},
	-- Renew		
		[GetSpellInfo(139)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Renew",
					[0] = { School = { "Holy", "Healing" }, eDot = true, eDuration = 15, sTicks = 3, },
					[1] = { 45, 45, spellLevel = 8, },
					[2] = { 100, 100, spellLevel = 14, },
					[3] = { 175, 175, spellLevel = 20, },
					[4] = { 245, 245, spellLevel = 26, },
					[5] = { 315, 315, spellLevel = 32, },
					[6] = { 400, 400, spellLevel = 38, },
					[7] = { 510, 510, spellLevel = 44, },
					[8] = { 650, 650, spellLevel = 50, },
					[9] = { 810, 810, spellLevel = 56, },
					[10] = { 970, 970, spellLevel = 60, },
					[11] = { 1010, 1010, spellLevel = 65, },
					[12] = { 1110, 1110, spellLevel = 70, },
					[13] = { 1235, 1235, spellLevel = 75, },
					[14] = { 1400, 1400, spellLevel = 80, },
		},
	-- Binding Heal
		[GetSpellInfo(32546)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Binding Heal",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, BaseIncrease = true, LevelIncrease = 7 }, --Need to find LevelIncrease -DALLYTEMP
					[1] = { 1042, 1338, 60, 61, spellLevel = 64, }, --Guess --DALLYTEMP
					[2] = { 1619, 2081, 0, 0, spellLevel = 72, },
					[3] = { 1952, 2508, 0, 0, spellLevel = 78, },
		},
	-- Prayer of Mending
		[GetSpellInfo(33076)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Prayer of Mending",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, Cooldown = 10, sHits = 5, sFactor = 5, NoDPS = true },
					[1] = { 800, 800, spellLevel = 68, },
					[2] = { 905, 905, spellLevel = 74, },
					[3] = { 1043, 1043, spellLevel = 79, },
		},
	-- Smite			
		[GetSpellInfo(585)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Smite",
					[0] = { School = "Holy", canCrit = true, castTime = 2.5, BaseIncrease = true, LevelIncrease = 5 },
					[1] = { 13, 17, 2, 3, spellLevel = 1, castTime = 1.5, },
					[2] = { 25, 31, 3, 3,  spellLevel = 6, castTime = 2.0, },
					[3] = { 54, 62, 4, 5, spellLevel = 14, },
					[4] = { 91, 105, 6, 7, spellLevel = 22, },
					[5] = { 150, 170, 8, 8, spellLevel = 30, },
					[6] = { 212, 240, 10, 10, spellLevel = 38, },
					[7] = { 287, 323, 12, 12, spellLevel = 46, },
					[8] = { 371, 415, 13, 14, spellLevel = 54, },
					[9] = { 405, 453, 17, 17, spellLevel = 61, },
					[10] = { 545, 611, 22, 23, spellLevel = 69, }, --Guess --DALLYTEMP
					[11] = { 604, 676, 0, 0, spellLevel = 74, },					
					[12] = { 707, 793, 0, 0, spellLevel = 79, },					
		},
	-- Holy Fire
		[GetSpellInfo(14914)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Holy Fire",
					[0] = { School = "Holy", canCrit = true, castTime = 2, Cooldown = 10, eDuration = 7, sTicks = 1, bonusFactor = 0.5711, dotFactor = 0.168, BaseIncrease = true,  LevelIncrease = 6 },
					[1] = { 102, 128, 6, 6, hybridDotDmg= 21, spellLevel = 20, },
					[2] = { 137, 173, 10, 11, hybridDotDmg= 28, spellLevel = 24, },
					[3] = { 200, 252, 12, 12, hybridDotDmg= 42, spellLevel = 30, },
					[4] = { 267, 339, 13, 14, hybridDotDmg= 56, spellLevel = 36, },
					[5] = { 348, 440, 15, 15, hybridDotDmg= 70, spellLevel = 42, },
					[6] = { 430, 546, 17, 18, hybridDotDmg= 91, spellLevel = 48, },
					[7] = { 529, 671, 19, 20, hybridDotDmg= 112, spellLevel = 54, },
					[8] = { 639, 811, 20, 21, hybridDotDmg= 126, spellLevel = 60, },
					[9] = { 705, 895, 22, 23, hybridDotDmg= 147, spellLevel = 66, }, --Guess --DALLYTEMP
					[10] = { 732, 928, 0, 0, hybridDotDmg= 287, spellLevel = 72, },
					[11] = { 890, 1130, 0, 0, hybridDotDmg= 350, spellLevel = 78, },				
		},
	-- Holy Nova
		[GetSpellInfo(15237)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Holy Nova",
					[0] = { School = { "Holy", "Holy Nova Damage" }, canCrit = true, bonusFactor = 0.1606, BaseIncrease = true, LevelIncrease = 7 },
					[1] = { 28, 32, 1, 2, spellLevel = 20, },
					[2] = { 50, 58, 2, 3, spellLevel = 28, },
					[3] = { 76, 88, 3, 4, spellLevel = 36, },
					[4] = { 106, 123, 4, 4, spellLevel = 44, },
					[5] = { 140, 163, 6, 6, spellLevel = 52, },
					[6] = { 181, 210, 7, 7, spellLevel = 60, },
					[7] = { 242, 280, 8, 8, spellLevel = 68, }, --Guess --DALLYTEMP
					[8] = { 333, 387, 0, 0, spellLevel = 75, },
					[9] = { 398, 462, 0, 0, spellLevel = 80, },
			["Secondary"] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Holy Nova",
					[0] = { School = { "Holy", "Healing", "Holy Nova Heal" }, canCrit = true, bonusFactor = 0.1606, BaseIncrease = true, LevelIncrease = 7 },
					[1] = { 52, 60, 2, 3, spellLevel = 20, },
					[2] = { 86, 98, 3, 3, spellLevel = 28, },
					[3] = { 121, 139, 3, 4, spellLevel = 36, },
					[4] = { 161, 188, 4, 4, spellLevel = 44, },
					[5] = { 235, 272, 4, 4, spellLevel = 52, },
					[6] = { 302, 350, 5, 6, spellLevel = 60, },
					[7] = { 384, 446, 6, 6, spellLevel = 68, }, --Guess --DALLYTEMP
					[8] = { 611, 709, 0, 0, spellLevel = 75, },
					[9] = { 713, 827, 0, 0, spellLevel = 80, },
			}
		},
	-- Gift of the Naaru
		[GetSpellInfo(28880)] = {
					--BASE OK, INCREASE OK?, COEFFICIENT X
					["Name"] = "Gift of the Naaru",
					[0] = { School = { "Holy", "Healing" }, Cooldown = 180, eDot = true, eDuration = 15, sTicks = 3, bonusFactor = 1, BaseIncrease = true, NoLowLevelPenalty = true, NoDownRank = true, NoSchoolTalents = true, },
					[1] = { 50, 50, 1185, 1185, spellLevel = 1, },
		},
	-- Lightwell
		[GetSpellInfo(724)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Lightwell",
					[0] = { School = { "Holy", "Healing" }, Cooldown = 180, bonusFactor = 1, eDot = true, eDuration = 6, sTicks = 2, Stacks = 10 },
					[1] = { 801, 801, spellLevel = 40, },
					[2] = { 1164, 1164, spellLevel = 50, },
					[3] = { 1599, 1599, spellLevel = 60, },
					[4] = { 2361, 2361, spellLevel = 70, },		
					[5] = { 3915, 3915, spellLevel = 75, },
					[6] = { 4620, 4620, spellLevel = 80, },					
		},
	-- Divine Hymn
		[GetSpellInfo(64843)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					--TODO LATER: BASE ALTERED ON PTR 3.1.2
					["Name"] = "Divine Hymn", --(needs another pass...this is a channeled spell that auto-switches targets, so it is a bit weird)
					[0] = { School = { "Holy", "Healing" }, sHits = 12, eAoe = true, bonusFactor = 1.5/7},
					[1] = { 4320, 4774, spellLevel = 80 },
		},
	-- Mind Sear
		[GetSpellInfo(48045)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Mind Sear",
					[0] = { School = "Shadow", sHits = 5, castTime = 5, bonusFactor = 0.7143 },
					[1] = { 183, 197, spellLevel = 75},
					[2] = { 212, 228, spellLevel = 80},
		},
	-- Penance
		[GetSpellInfo(53007)] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Penance",
					[0] = { School = { "Holy", "Healing" }, sHits = 3, castTime = 2, bonusFactor = 0.99 },
					[1] = { 670, 756, spellLevel = 60},
					[2] = { 805, 909, spellLevel = 70},
					[3] = { 1278, 1442, spellLevel = 75},
					[4] = { 1484, 1676, spellLevel = 80},
				["Secondary"] = {
					--BASE OK, INCREASE X, COEFFICIENT X
					["Name"] = "Penance",
					[0] = { School = "Holy", sHits = 3, castTime = 2, bonusFactor = 0.722, BaseIncrease = true, LevelIncrease = 10 },
					[1] = { 240, 240, 12, 12, spellLevel = 60},
					[2] = { 292, 292, 14, 15, spellLevel = 70},
					[3] = { 333, 333, 0, 0, spellLevel = 75},
					[4] = { 375, 375, 0, 0, spellLevel = 80},
				}
		},		
	}
	
	self.talentInfo = { 
		--SHADOW:
		--Darkness
		[GetSpellInfo(15259)] = { 	[1] = { Effect = 0.02, Spells = "Shadow", Add = true }, },
		--Shadow Focus
		[GetSpellInfo(15260)] = { 	[1] = { Effect = 1, Spells = "Shadow", ModType = "hitPerc" }, },
		--Improved Shadow Word: Pain
		[GetSpellInfo(15275)] = { 	[1] = { Effect = 0.03, Spells = "Shadow Word: Pain", Add = true }, },
		--Improved Mind Blast
		[GetSpellInfo(15273)] = { 	[1] = { Effect = -0.5, Spells = "Mind Blast", ModType = "cooldown" }, },
		--Mind Melt
		[GetSpellInfo(14910)] = {	[1] = { Effect = 2, Spells = { "Mind Blast", "Mind Flay", "Mind Sear" }, ModType = "critPerc", }, 
						[2] = { Effect = 3, Spells = { "Shadow Word: Pain", "Devouring Plague", "Vampiric Touch" } , ModType = "critPerc", }, },		
		--Improved Devouring Plague
		[GetSpellInfo(63625)] = {	[1] = { Effect = 0.05, Spells = "Devouring Plague", Add = true }, 
						[2] = { Effect = 0.05, Spells = "Devouring Plague", ModType = "Amount", Value = "Improved Devouring Plague", }, },		
		--Shadow Power
		[GetSpellInfo(33221)] = { 	[1] = { Effect = 0.2, Spells = { "Mind Blast", "Shadow Word: Death", "Mind Flay" }, ModType = "critM", }, },
		--Misery
		[GetSpellInfo(33191)] = {	[1] = { Effect = 0.05, Spells = { "Mind Blast", "Mind Flay", "Mind Sear" }, ModType = "SpellDamage", Multiply = true }, },
		--Twisted Faith
		[GetSpellInfo(47573)] = {	[1] = { Effect = 0.02, Spells = { "Mind Flay", "Mind Blast" }, ModType = "Amount", Value = "Twisted Faith" }, },					
		
		--HOLY:
		--Improved Renew
		[GetSpellInfo(14908)] = { 	[1] = { Effect = 0.05, Spells = "Renew", Add = true }, },
		--Searing Light
		[GetSpellInfo(14909)] = { 	[1] = { Effect = 0.05, Spells = { "Smite", "Holy Fire", "Penance", "Holy Nova Damage" }, Add = true }, },
		--Spiritual Healing
		[GetSpellInfo(14898)] = {	[1] = { Effect = 0.02, Spells = "Healing", Add = true }, },
		--Empowered Healing
		[GetSpellInfo(33158)] = { 	[1] = { Effect = 0.08, Spells = "Greater Heal", ModType = "SpellDamage", Multiply = true },
						[2] = { Effect = 0.04, Spells = { "Flash Heal", "Binding Heal" }, ModType = "SpellDamage", Multiply = true }, },
		--Divine Providence (TODO: How do we represent cooldown reduction in seconds instead of percent?)
		[GetSpellInfo(47562)] = { 	[1] = { Effect = 0.02, Spells = { "Circle of Healing", "Binding Heal", "Divine Hymn", "Holy Nova Heal", "Prayer of Healing", "Prayer of Mending" }, Add = true }, --Guessed ass additive, confirm?
						[2] = { Effect = -0.666, Spells = "Prayer of Mending", ModType = "cooldown" }, },
		--Empowered Renew
		[GetSpellInfo(63534)] = {	[1] = { Effect = 0.05, Spells = "Renew", ModType = "SpellDamage", Multiply = true, }, 
						[2] = { Effect = 0.05, Spells = "Renew", ModType = "Amount", Value = "Empowered Renew", }, },
		--Test of Faith
		[GetSpellInfo(47558)] = {	[1] = { Effect = 0.04, Spells = "Healing", ModType = "Amount", Value = "Test of Faith" }, },
		--Blessed Resilience
		[GetSpellInfo(33142)] = {	[1] = { Effect = 0.01, Spells = "Healing", Add = true }, },
		
		
		--DISCIPLINE:
		--Improved Power Word: Shield
		[GetSpellInfo(14748)] = { 	[1] = { Effect = 0.05, Spells = "Power Word: Shield", }, }, --Seems to be multiplicative. Confirm?
		--Twin Disciplines
		[GetSpellInfo(47586)] = { 	[1] = { Effect = 0.01, Spells = { "Shadow Word: Pain", "Renew", "Power Word: Shield", "Holy Nova", "Prayer of Mending", "Devouring Plague", "Shadow Word: Death", "Desperate Prayer", "Circle of Healing" }, Add = true  }, },
		--Borrowed Time
		[GetSpellInfo(52795)] = {	[1] = { Effect = 0.08, Spells = "Power Word: Shield", ModType = "SpellDamage" }, }, --Seems to be additive. Confirm?
		--Focused Power
		[GetSpellInfo(33190)] = {	[1] = { Effect = 0.02, Spells = "All", Add = true }, },
		--Soul Warding
		[GetSpellInfo(63574)] = {	[1] = { Effect = -4, Spells = "Power Word: Shield", ModType = "cooldown" }, },
		--Renewed Hope
		[GetSpellInfo(57472)] = {	[1] = { Effect = 2, Spells = { "Flash Heal", "Greater Heal", "Penance" }, ModType = "Amount", Value = "Renewed Hope" }, },
		}
end